package storage

import (
	"fmt"

	"github.com/spf13/viper"
)

type Storage interface {
	CreateDiag(Diag) error
	GetDiag(string) (*Diag, error)
	GetDiags(namespaces []string) ([]Diag, error)
	UpdateDiag(Diag) error}
type StorageImpl struct {
}

func NewStorage(cfg *viper.Viper) (Storage, error) {
	var (
		storage_type = cfg.GetString("storage.db.type")
	)

	switch storage_type {
	case "mongodb":
		s, err := NewMongoDBStorage(cfg)
		return s, err
	default:
		return nil, fmt.Errorf("storage type %v is not supported", storage_type)
	}
}
